#include<stdio.h>
#include<stdlib.h>
#include<time.h>
#include"neuralnet.h"

#define INPUTSIZE 3
#define OUTPUTSIZE 1

#define LOOPNUM 50000

double teacher[4][3] = {
	{0, 0, 0},
	{1, 0, 0},
	{0, 1, 0},
	{1, 1, 1}
};

int main(int argc, char *argv[])
{
	double input[INPUTSIZE], output[OUTPUTSIZE];
	double weight_io[INPUTSIZE][OUTPUTSIZE];
	int i, j;

	srand((unsigned)time(NULL));

	for(i=0; i<INPUTSIZE; i++){
		for(j=0; j<OUTPUTSIZE; j++){
			weight_io[i][j] = ((double)rand()/RAND_MAX)/10;
		}
	}

	for(i=0; i<LOOPNUM; i++){
		for(j=0; j<4; j++){
			input[0] = teacher[j][0];
			input[1] = teacher[j][1];
			Forward(input, output, INPUTSIZE, OUTPUTSIZE, weight_io);
			Backward(input, output, INPUTSIZE, OUTPUTSIZE, weight_io, 0.01, &teacher[j][2]);
		}
	}

	for(i=0; i<=1; i++){
		for(j=0; j<=1; j++){
			input[0] = i;
			input[1] = j;
			Forward(input, output, INPUTSIZE, OUTPUTSIZE, weight_io);
			printf("INPUT: %d %d OUTPUT: %f\n", i, j, output[0]);
		}
	}

	return 0;
}

